#!/bin/sh

for DISK in $(list-devices disk); do \
    dd if=/dev/zero of=${DISK} bs=512 count=1; \
    parted -s ${DISK} mklabel gpt; \
done; \
if grep -q QEMU /proc/cpuinfo || dmesg | grep -q 'Manufacturer: QEMU' ; then \
	export WITHOUT_SWAP=yes ;\
fi ;\
set $(list-devices disk); \
let numb=$#/2; \
DISKA=$1; \
DISKB=$2; \
SIZE1=$(fdisk -l "${DISKA}" 2>/dev/null|grep Disk|grep dev|cut -d' ' -f5); \
MBR_LIMIT=2000000000000 ;\
if [ -b "${DISKB}" ]; then \
    SIZE1=$(fdisk -l "${DISKA}" 2>/dev/null|grep Disk|grep dev|cut -d' ' -f5); \
    SIZE2=$(fdisk -l "${DISKB}" 2>/dev/null|grep Disk|grep dev|cut -d' ' -f5); \
	if [ -n ${SIZE1} ] && [ -n ${SIZE2} ] && [ "${SIZE1}" = "${SIZE2}" ] && [ -z "${WITHOUT_SWAP}" ]; then \
	    USE_MIRROR=yes; \
	else \
	    USE_MIRROR=no; \
	fi; \
fi; \

bootsize=256

if [ ${SIZE1} -gt ${MBR_LIMIT} ]; then \
	debconf-set partman-basicfilesystems/choose_label gpt ;\
	debconf-set partman-partitioning/choose_label gpt ;\
	debconf-set partman-basicfilesystems/default_label gpt ;\
	debconf-set partman-partitioning/default_label gpt ;\
	debconf-set partman-partitioning/choose_label gpt ;\
	if [ "#${USE_MIRROR}" = "#yes" ]; then \
		debconf-set partman-auto/disk "$DISKA $DISKB";\
		debconf-set partman-auto/method "raid";\
    if [ -d /sys/firmware/efi ]; then \
      debconf-set partman-auto/expert_recipe "multiraid :: \
        300 200 500 free $iflabel{ gpt } $reusemethod{ } method{ efi } format{ } . \
        ${bootsize} 50 ${bootsize} raid $primary{ } method{ raid } . \
        128 512 100% raid method{ raid } . \
        1024 10000 1000000000 raid method{ raid } . ";\
    else \
      debconf-set partman-auto/expert_recipe "multiraid :: \
        1 1 1 free $iflabel{ gpt } method{ biosgrub } . \
        ${bootsize} 50 ${bootsize} raid $primary{ } method{ raid } . \
        128 512 100% raid method{ raid } . \
        1024 10000 1000000000 raid method{ raid } . ";\
    fi ;\
		debconf-set partman-auto-raid/recipe " \
			1 2 0 ext2 /boot ${DISKA}2#${DISKB}2 . \
			1 2 0 swap - ${DISKA}3#${DISKB}3 . \
			1 2 0 ext4 / ${DISKA}4#${DISKB}4 . ";\
#		debconf-set grub-installer/bootdev "${DISKA} ${DISKB}";\
		echo "${DISKA} ${DISKB}" >> /tmp/grub_devices ;\
	else \
		debconf-set partman-auto/disk "$DISKA";\
		debconf-set partman-auto/method "regular";\
		if [ -n "${WITHOUT_SWAP}" ]; then \
			debconf-set partman-auto/expert_recipe "boot-root :: \
				1 1 1 free $gptonly{ } $primary{ } $bios_boot{ } method{ biosgrub } . \
				${bootsize} 50 ${bootsize} ext2 $primary{ } $bootable{ } method{ format } format{ } use_filesystem{ } filesystem{ ext2 } mountpoint{ /boot } . \
				1024 10000 1000000000 ext4 method{ format } format{ } use_filesystem{ } filesystem{ ext4 } mountpoint{ / } . ";\
		else \
      if [ -d /sys/firmware/efi ]; then \
        debconf-set partman-auto/expert_recipe "boot-root :: \
          300 200 500 free $iflabel{ gpt } $reusemethod{ } method{ efi } format{ } . \
          ${bootsize} 50 ${bootsize} ext2 $primary{ } $bootable{ } method{ format } format{ } use_filesystem{ } filesystem{ ext2 } mountpoint{ /boot } . \
          128 512 100% linux-swap method{ swap } format{ } . \
          1024 10000 1000000000 ext4 method{ format } format{ } use_filesystem{ } filesystem{ ext4 } mountpoint{ / } . ";\
      else \
        debconf-set partman-auto/expert_recipe "boot-root :: \
          1 1 1 free $gptonly{ } $primary{ } $bios_boot{ } method{ biosgrub } . \
          ${bootsize} 50 ${bootsize} ext2 $primary{ } $bootable{ } method{ format } format{ } use_filesystem{ } filesystem{ ext2 } mountpoint{ /boot } . \
          128 512 100% linux-swap method{ swap } format{ } . \
          1024 10000 1000000000 ext4 method{ format } format{ } use_filesystem{ } filesystem{ ext4 } mountpoint{ / } . ";\
        fi ;\
		fi ;\
		debconf-set grub-installer/bootdev "$DISKA";\
	fi ;\
else \
  if [ -d /sys/firmware/efi ]; then \
    debconf-set partman-basicfilesystems/choose_label gpt ;\
    debconf-set partman-partitioning/choose_label gpt ;\
    debconf-set partman-basicfilesystems/default_label gpt ;\
    debconf-set partman-partitioning/default_label gpt ;\
    debconf-set partman-partitioning/choose_label gpt ;\
  else \
    debconf-set partman-basicfilesystems/choose_label msdos ;\
    debconf-set partman-partitioning/choose_label msdos ;\
    debconf-set partman-basicfilesystems/default_label msdos ;\
    debconf-set partman-partitioning/default_label msdos ;\
    debconf-set partman-partitioning/choose_label msdos ;\
  fi ;\
	if [ "#${USE_MIRROR}" = "#yes" ]; then \
		debconf-set partman-auto/disk "$DISKA $DISKB";\
		debconf-set partman-auto/method "raid";\
    if [ -d /sys/firmware/efi ]; then \
      debconf-set partman-auto/expert_recipe "multiraid :: \
        300 200 500 free $iflabel{ gpt } $reusemethod{ } method{ efi } format{ } . \
        ${bootsize} 50 ${bootsize} raid $primary{ } method{ raid } . \
        128 512 100% raid method{ raid } . \
        1024 10000 1000000000 raid method{ raid } . ";\
    else \
      debconf-set partman-auto/expert_recipe "multiraid :: \
        ${bootsize} 50 ${bootsize} raid $primary{ } method{ raid } . \
        128 512 100% raid method{ raid } . \
        1024 10000 1000000000 raid method{ raid } . ";\
    fi ;\
		debconf-set partman-auto-raid/recipe " \
			1 2 0 ext2 /boot ${DISKA}1#${DISKB}1 . \
			1 2 0 swap - ${DISKA}5#${DISKB}5 . \
			1 2 0 ext4 / ${DISKA}6#${DISKB}6 . ";\
#		debconf-set grub-installer/bootdev "${DISKA} ${DISKB}";\
		echo "${DISKA} ${DISKB}" >> /tmp/grub_devices ;\
	else \
		debconf-set partman-auto/disk "$DISKA";\
		debconf-set partman-auto/method "regular";\
		if [ -n "${WITHOUT_SWAP}" ]; then \
			debconf-set partman-auto/expert_recipe "boot-root :: \
				${bootsize} 50 ${bootsize} ext2 $primary{ } $bootable{ } method{ format } format{ } use_filesystem{ } filesystem{ ext2 } mountpoint{ /boot } . \
				1024 10000 1000000000 ext4 method{ format } format{ } use_filesystem{ } filesystem{ ext4 } mountpoint{ / } . ";\
		else \
      if [ -d /sys/firmware/efi ]; then \
        debconf-set partman-auto/expert_recipe "boot-root :: \
          300 200 500 free $iflabel{ gpt } $reusemethod{ } method{ efi } format{ } . \
          ${bootsize} 50 ${bootsize} ext2 $primary{ } $bootable{ } method{ format } format{ } use_filesystem{ } filesystem{ ext2 } mountpoint{ /boot } . \
          128 512 100% linux-swap method{ swap } format{ } . \
          1024 10000 1000000000 ext4 method{ format } format{ } use_filesystem{ } filesystem{ ext4 } mountpoint{ / } . ";\
      else \
        debconf-set partman-auto/expert_recipe "boot-root :: \
          ${bootsize} 50 ${bootsize} ext2 $primary{ } $bootable{ } method{ format } format{ } use_filesystem{ } filesystem{ ext2 } mountpoint{ /boot } . \
          128 512 100% linux-swap method{ swap } format{ } . \
          1024 10000 1000000000 ext4 method{ format } format{ } use_filesystem{ } filesystem{ ext4 } mountpoint{ / } . ";\
        fi ;\
		fi ;\
		debconf-set grub-installer/bootdev "$DISKA";\
	fi ;\
fi



